var m = Object.defineProperty;
var f = (t, e, n) => e in t ? m(t, e, { enumerable: !0, configurable: !0, writable: !0, value: n }) : t[e] = n;
var r = (t, e, n) => f(t, typeof e != "symbol" ? e + "" : e, n);
var c = /* @__PURE__ */ ((t) => (t.IN = "in", t.OUT = "out", t))(c || {}), I = /* @__PURE__ */ ((t) => (t.NUMBER = "number", t.NUMBER_ARRAY = "numberarray", t.STRING = "string", t.STRING_ARRAY = "stringarray", t.BOOLEAN = "boolean", t.BOOLEAN_ARRAY = "booleanarray", t.OBJECT = "object", t.OBJECT_ARRAY = "objectarray", t.UNDEFINED = "undefined", t))(I || {}), l = /* @__PURE__ */ ((t) => (t.STARTED = "started", t.RUNNING = "running", t.FINISHED_SUCCESSFULLY = "finishedSuccessfully", t.FINISHED_WITH_ERRORS = "finishedWithErrors", t))(l || {}), B = /* @__PURE__ */ ((t) => (t.INFO = "info", t.DEBUG = "debug", t.WARN = "warn", t.ERROR = "error", t))(B || {});
class b {
  constructor() {
    r(this, "logs", []);
    r(this, "blockId");
    r(this, "blockName");
    r(this, "socketName");
  }
  setContext(e, n, s) {
    this.blockId = e, this.blockName = n, this.socketName = s;
  }
  async addLog(e) {
    this.logs.push(e);
  }
  async debug(e, n) {
    this.addLog({
      blockId: this.blockId,
      blockName: this.blockName,
      socketName: this.socketName,
      text: e,
      extra: n,
      timestamp: Date.now(),
      level: "debug"
      /* DEBUG */
    });
  }
  async error(e, n) {
    this.addLog({
      blockId: this.blockId,
      blockName: this.blockName,
      socketName: this.socketName,
      text: e,
      extra: n,
      timestamp: Date.now(),
      level: "error"
      /* ERROR */
    });
  }
  async info(e, n) {
    this.addLog({
      blockId: this.blockId,
      blockName: this.blockName,
      socketName: this.socketName,
      text: e,
      extra: n,
      timestamp: Date.now(),
      level: "info"
      /* INFO */
    });
  }
  async warn(e, n) {
    this.addLog({
      blockId: this.blockId,
      blockName: this.blockName,
      socketName: this.socketName,
      text: e,
      extra: n,
      timestamp: Date.now(),
      level: "warn"
      /* WARN */
    });
  }
  getLogs() {
    return this.logs;
  }
}
class y {
  constructor() {
    r(this, "blockDefinitions", {});
  }
  addBlockDefinition(e, n) {
    this.blockDefinitions[e] = n;
  }
  async getBlockDefinition(e) {
    const n = this.blockDefinitions[e];
    if (!n) throw new Error("block definition not found by id: " + e);
    return n;
  }
  getBlockById(e, n) {
    const s = e.blocks.find((o) => o.id === n);
    if (!s) throw new Error("block not found by id: " + n);
    return s;
  }
  getSocketConnectionsBySource(e, n, s) {
    return e.connections && e.connections.filter(
      (o) => o.sourceBlockId === n && o.sourceSocketName === s
    );
  }
  getLogger() {
    return new b();
  }
  // eslint-disable-next-line max-lines-per-function
  async triggerWorkflowBlock(e, n, s, o) {
    o === void 0 && (o = { logger: this.getLogger() });
    const d = this.getBlockById(e, n), k = await this.getBlockDefinition(d.definitionId);
    if (o.logger.setContext(n, d.definitionId, s.socketName), await o.logger.info(
      `Executing block "${d.definitionId}", socket: ${s.socketName}`,
      JSON.stringify(
        {
          blockId: n,
          data: s.data,
          configuration: d.configuration
        },
        void 0,
        2
      ).substring(0, 2048)
    ), k.getSockets().find(
      (i) => i.name === s.socketName && i.direction === c.IN
    ) === void 0)
      throw new Error("block '" + n + "' has no input socket with name " + s.socketName);
    if (e.connections instanceof Array)
      for (const i of e.connections) {
        const N = this.getBlockById(e, i.sourceBlockId);
        if ((await this.getBlockDefinition(N.definitionId)).getSockets().find(
          (g) => g.name === i.sourceSocketName && g.direction === c.OUT
        ) === void 0)
          throw new Error(
            "block '" + i.sourceBlockId + "' has no output socket with name " + i.sourceSocketName
          );
        const u = this.getBlockById(e, i.targetBlockId);
        if ((await this.getBlockDefinition(u.definitionId)).getSockets().find(
          (g) => g.name === i.targetSocketName && g.direction === c.IN
        ) === void 0)
          throw new Error(
            "block '" + i.targetBlockId + "' has no input socket with name " + i.targetSocketName
          );
      }
    let a;
    try {
      s.configuration = d.configuration, a = await k.executeBlock(s, o);
    } catch (i) {
      return await o.logger.error("Uncaught Exception: " + i.message), {
        logs: o.logger.getLogs(),
        data: void 0,
        status: l.FINISHED_WITH_ERRORS
      };
    }
    if (a)
      if (a.socketName) {
        const i = this.getSocketConnectionsBySource(
          e,
          n,
          a.socketName
        );
        if (i instanceof Array && i.length > 0) {
          if (i.length > 1) throw new Error("more than one output connection is currently not allowed");
          const N = {
            socketName: i[0].targetSocketName,
            data: a.data
          };
          return this.triggerWorkflowBlock(
            e,
            i[0].targetBlockId,
            N,
            o
          );
        } else
          return {
            data: a.data,
            logs: o.logger.getLogs(),
            status: l.FINISHED_SUCCESSFULLY
          };
      } else
        return {
          data: a.data,
          logs: o.logger.getLogs(),
          status: l.FINISHED_SUCCESSFULLY
        };
    return {
      logs: o.logger.getLogs(),
      data: void 0,
      status: l.FINISHED_SUCCESSFULLY
    };
  }
}
function h(t, e, n) {
  return {
    direction: n,
    name: t,
    type: e
  };
}
function L(t, e) {
  return h(t, e, c.IN);
}
function U(t, e) {
  return h(t, e, c.OUT);
}
export {
  b as DefaultWorkflowLogger,
  c as SocketDirection,
  I as SocketType,
  y as WorkflowEngine,
  l as WorkflowExecutionStatus,
  B as WorkflowLogLevel,
  L as createInputSocket,
  U as createOutputSocket,
  h as createSocket
};
